"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderHook = renderHook;
exports.testHook = testHook;
Object.defineProperty(exports, "cleanup", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.cleanup;
  }
});
Object.defineProperty(exports, "act", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.act;
  }
});

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

function TestHook(_ref) {
  var callback = _ref.callback,
      hookProps = _ref.hookProps,
      children = _ref.children;

  try {
    children(callback(hookProps));
  } catch (e) {
    children(undefined, e);
  }

  return null;
}

function resultContainer() {
  var value = null;
  var error = null;
  var resolvers = [];
  var result = {
    get current() {
      if (error) {
        throw error;
      }

      return value;
    },

    get error() {
      return error;
    }

  };
  return {
    result: result,
    addResolver: function addResolver(resolver) {
      resolvers.push(resolver);
    },
    updateResult: function updateResult(val, err) {
      value = val;
      error = err;
      resolvers.splice(0, resolvers.length).forEach(function (resolve) {
        return resolve();
      });
    }
  };
}

function renderHook(callback, _ref2) {
  if (_ref2 === void 0) {
    _ref2 = {};
  }

  var _ref3 = _ref2,
      initialProps = _ref3.initialProps,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref3, ["initialProps"]);

  var _resultContainer = resultContainer(),
      result = _resultContainer.result,
      updateResult = _resultContainer.updateResult,
      addResolver = _resultContainer.addResolver;

  var hookProps = {
    current: initialProps
  };

  var toRender = function toRender() {
    return _react.default.createElement(TestHook, {
      callback: callback,
      hookProps: hookProps.current
    }, updateResult);
  };

  var _render = (0, _reactTestingLibrary.render)(toRender(), options),
      unmount = _render.unmount,
      rerenderComponent = _render.rerender;

  return {
    result: result,
    waitForNextUpdate: function waitForNextUpdate() {
      return new Promise(function (resolve) {
        return addResolver(resolve);
      });
    },
    rerender: function rerender(newProps) {
      if (newProps === void 0) {
        newProps = hookProps.current;
      }

      hookProps.current = newProps;
      rerenderComponent(toRender());
    },
    unmount: unmount
  };
}

function testHook() {
  console.warn('`testHook` has been deprecated and will be removed in a future release.  Please use `renderHook` instead.');
  return renderHook.apply(void 0, arguments);
}